Subject: Re: [Roll] Closing on the IPR

From: Dan Lang <[email-masked]>
Date: Sun, 14 Feb 2010 21:41:54 -0800

Hi Ruben,
A couple of points that I'd like to clarify in response to your  
email.  Again, I recommend that you check with your company's  
attorneys but at least let me suggest some things to ask them about.

1.  No one is being asked to "renounce their IPR."     But, per our  
statement, an entity that wants to make money on or otherwise exploit  
their patents against Cisco products might have to pay something for a  
license to Cisco's patents.  That seems fair to me, but more  
importantly, it seems fair to a lot of people who find sufficient  
assurance with our commitment to make numerous IETF standards  
successful.

2.  We would never claim that our intellectual property provides an  
"umbrella" for the industry.   Having the right to use one company's  
patents does not give you the right to use other patents if they are  
relevant.   Potential exposure to unknown third party patents is  
always a concern in the information technology industry.  Due to the  
large number of patents and the challenges of searching for them and  
evaluating them, it would be almost impossible to reliably identify  
all of the relevant patents for a particular product or standard.  But  
our patents and our licensing commitment are not the cause of this  
problem.  Even if our patents did not exist at all, the problem would  
still be there.   That is why I agree with some of the commenters who  
pointed out that it is very difficult to avoid intellectual property  
concerns entirely because they cannot all be known.
Best regards,
Dan

Dan Lang
Director, Intellectual Property
Legal Services
Cisco Systems, Inc.

---

From: Jon Smirl <[email-masked]>
Date: Mon, 15 Feb 2010 08:33:23 -0500

On Mon, Feb 15, 2010 at 12:41 AM, Dan Lang <[email-masked]> wrote:

> Hi Ruben,
> A couple of points that I'd like to clarify in response to your email.
>  Again, I recommend that you check with your company's attorneys but at
> least let me suggest some things to ask them about.
>
> statement, an entity that wants to make money on or otherwise exploit their
> patents against Cisco products might have to pay something for a license to
> Cisco's patents.  That seems fair to me, but more importantly, it seems fair
> to a lot of people who find sufficient assurance with our commitment to make
> numerous IETF standards successful.
>

>From a legal sense, is your statement compatible with the GPL? I just want
to ensure that we can build a GPL'd version of RPL. I don't want to repeat
the problems with Zigbee where their licensing is incompatible with the GPL.

> "umbrella" for the industry.   Having the right to use one company's patents
> does not give you the right to use other patents if they are relevant.
> Potential exposure to unknown third party patents is always a concern in the
> information technology industry.  Due to the large number of patents and the
> challenges of searching for them and evaluating them, it would be almost
> impossible to reliably identify all of the relevant patents for a particular
> product or standard.  But our patents and our licensing commitment are not
> the cause of this problem.  Even if our patents did not exist at all, the
> problem would still be there.   That is why I agree with some of the
> commenters who pointed out that it is very difficult to avoid intellectual
> property concerns entirely because they cannot all be known.
>

Trolls are everywhere and can't be identified ahead of time. Do you feel
that the GPL and the set of companies surrounding the Linux kernel somewhat
protects it from troll attacks? Would implementing the reference version of
RPL inside the Linux kernel provide added protection to RPL users?

As we reasonably sure that there aren't problem patents held by direct
competitors who aren't participating in ROLL and might be interested in
disrupting ROLL?

> _______________________________________________
> Roll mailing list
> [email-masked]
> https://www.ietf.org/mailman/listinfo/roll
>
>

-- 
Jon Smirl
[email-masked]

---

From: Dan Lang <[email-masked]>
Date: Mon, 15 Feb 2010 15:33:16 -0800

Hi Jon:

I am not your lawyer, so I unfortunately won’t be able to answer your  
question (“From a legal sense, is your statement compatible with the  
GPL?”) in way that satisfies you.  However, I don’t think that having  
RPL inside the Linux kernel under a GPL license would somehow  
“protect” RPL and its implementers from patent "troll" attacks.  The  
entities you are worried about don’t typically have any products, and  
the GPL provides conditions on those who distribute or modify covered  
works, so they would not likely be bound by any of those conditions.    
If anything, they would have a larger pool of companies against  which  
to assert their patents.

Your last question highlights the risk of standard-setting generally;  
competitors or any third parties who aren’t participating in ROLL  
don’t necessarily have an obligation to disclose any of their patents  
to the IETF and may choose to wait until after the standard is  
finalized to demand fees (and not necessarily on reasonable and non- 
discriminatory terms) for RPL-compliant products.  This unfortunate  
fact will be true no matter what the RPL specification looks like.

Best regards,

Dan

On Feb 15, 2010, at 5:33 AM, Jon Smirl wrote:

> statement, an entity that wants to make money on or otherwise  
> exploit their patents against Cisco products might have to pay  
> something for a license to Cisco's patents.  That seems fair to me,  
> but more importantly, it seems fair to a lot of people who find  
> sufficient assurance with our commitment to make numerous IETF  
> standards successful.
>
> From a legal sense, is your statement compatible with the GPL? I  
> just want to ensure that we can build a GPL'd version of RPL. I  
> don't want to repeat the problems with Zigbee where their licensing  
> is incompatible with the GPL.
>
> all of the relevant patents for a particular product or standard.   
> But our patents and our licensing commitment are not the cause of  
> this problem.  Even if our patents did not exist at all, the problem  
> would still be there.   That is why I agree with some of the  
> commenters who pointed out that it is very difficult to avoid  
> intellectual property concerns entirely because they cannot all be  
> known.
>
> Trolls are everywhere and can't be identified ahead of time. Do you  
> feel that the GPL and the set of companies surrounding the Linux  
> kernel somewhat protects it from troll attacks? Would implementing  
> the reference version of RPL inside the Linux kernel provide added  
> protection to RPL users?
>
> As we reasonably sure that there aren't problem patents held by  
> direct competitors who aren't participating in ROLL and might be  
> interested in disrupting ROLL?
>
>
> Best regards,
> Dan
>
>
>
> Dan Lang

---

From: Jon Smirl <[email-masked]>
Date: Mon, 15 Feb 2010 19:40:49 -0500

On Mon, Feb 15, 2010 at 6:33 PM, Dan Lang <[email-masked]> wrote:

> question (“From a legal sense, is your statement compatible with the GPL?”)
> in way that satisfies you.  However, I don’t think that having RPL inside
> the Linux kernel under a GPL license would somehow “protect” RPL and its
> implementers from patent "troll" attacks.  The entities you are worried
> about don’t typically have any products, and the GPL provides conditions on
> those who distribute or modify covered works, so they would not likely be
> bound by any of those conditions.   If anything, they would have a larger
> pool of companies against  which to assert their patents.
>

My only goal is to try and keep the RPL spec in a form where GPL licensed
implementations are possible. I don't want to repeat the mess that Siemens
walked into when they tried to contribute Zigbee code to the kernel and
discovered that the Zigbee licenses weren't GPL incompatible.

> competitors or any third parties who aren’t participating in ROLL don’t
> necessarily have an obligation to disclose any of their patents to the IETF
> and may choose to wait until after the standard is finalized to demand fees
> (and not necessarily on reasonable and non-discriminatory terms) for
> RPL-compliant products.  This unfortunate fact will be true no matter what
> the RPL specification looks like.
>
> Best regards,
>
> Dan
>
>

-- 
Jon Smirl
[email-masked]

---

From: Philip Levis <[email-masked]>
Date: Mon, 15 Feb 2010 16:52:24 -0800

On Feb 15, 2010, at 4:40 PM, Jon Smirl wrote:

> I am not your lawyer, so I unfortunately won’t be able to answer your question (“From a legal sense, is your statement compatible with the GPL?”) in way that satisfies you.  However, I don’t think that having RPL inside the Linux kernel under a GPL license would somehow “protect” RPL and its implementers from patent "troll" attacks.  The entities you are worried about don’t typically have any products, and the GPL provides conditions on those who distribute or modify covered works, so they would not likely be bound by any of those conditions.   If anything, they would have a larger pool of companies against  which to assert their patents. 
>  
> My only goal is to try and keep the RPL spec in a form where GPL licensed implementations are possible. I don't want to repeat the mess that Siemens walked into when they tried to contribute Zigbee code to the kernel and discovered that the Zigbee licenses weren't GPL incompatible.

Jon,

This makes sense, but is in some ways independent of Cisco's IPR. No-one has yet reported a serious examination of whether Cisco's IPR overlaps with the current draft.

Phil

---

From: Geoff Mulligan <[email-masked]>
Date: Mon, 15 Feb 2010 18:50:19 -0700

Phil,
  Who is going to do this?  Can we not sort of assume that Cisco
believes that their IPR overlaps with the current draft.  If it didn't
then why are we continuing to discuss this.  The point would be moot and
we could get back to the fun stuff such as question of RPL design and
applicability to the various use cases such as SE2.0, building control
and home control.

	geoff

On Mon, 2010-02-15 at 16:52 -0800, Philip Levis wrote:
> >         I am not your lawyer, so I unfortunately won’t be able to
> >         answer your question (“From a legal sense, is your statement
> >         compatible with the GPL?”) in way that satisfies you.
> >         However, I don’t think that having RPL inside the Linux
> >         kernel under a GPL license would somehow “protect” RPL and
> >         its implementers from patent "troll" attacks.  The entities
> >         you are worried about don’t typically have any products, and
> >         the GPL provides conditions on those who distribute or
> >         modify covered works, so they would not likely be bound by
> >         any of those conditions.   If anything, they would have a
> >         larger pool of companies against  which to assert their
> >         patents. 
> >         
> >  
> > My only goal is to try and keep the RPL spec in a form where GPL
> > licensed implementations are possible. I don't want to repeat the
> > mess that Siemens walked into when they tried to contribute Zigbee
> > code to the kernel and discovered that the Zigbee licenses weren't
> > GPL incompatible.
> 
> 
> 
> 
> Jon,
> 
> 
> This makes sense, but is in some ways independent of Cisco's IPR.
> No-one has yet reported a serious examination of whether Cisco's IPR
> overlaps with the current draft.
> 
> 
> Phil

---

From: "Don Sturek" <[email-masked]>
Date: Mon, 15 Feb 2010 18:17:55 -0800

I guess I have a different view.....

Given ROLL RPL has had a lot of design work put into it, I would like to see some resolution that works on the business side.

"Getting back to the fun stuff" sounds like a serious schedule delay to me (which would not be good).

Don

-----Original Message-----
From: [email-masked] [mailto:[email-masked]] On Behalf Of Geoff Mulligan
Sent: Monday, February 15, 2010 5:50 PM
To: Philip Levis
Cc: [email-masked]; Dan Lang; [email-masked]
Subject: Re: [Roll] Closing on the IPR

Phil,

	geoff

---

From: Roger Alexander <[email-masked]>
Date: Mon, 15 Feb 2010 20:48:25 -0800 (PST)

The current focus on Cisco's IPR appears to stem from the
active involvement of Cisco personnel in the design and development of RPL
together with their open IPR declarations. The assumption is that
while any protocol design is vulnerable to the potential of unknown IPR,
Cisco's IPR is less potential and more of an explicit, known concern (even
though the IPR is being made openly available). If Cisco's declared IPR is removed as
a potential concern, then all companies achieve the 'comfort' of being equally
vulnerable to the vagaries of other unknown IPR. 

One possible compromise
therefore would be for Cisco to make its RPL-related IPR available to any and
all RPL implementations while still retaining the right to re-assert its IPR
claims but solely in the context of RPL-related suits brought against them by others. This
does not seem to be very far away from what Cisco’s legal representative, Dan, has
indicated. However, it is narrower in scope in that it would imply Cisco giving
up the option to reassert its potential RPL IPR claims in response to suits
that are not explicitly related to RPL (clearly a question to be addressed by
legal rather than technical representatives). 

Nonetheless, such a compromise could allow companies to feel that they
are on an equal footing with regard to potential vulnerability from unknown and
undeclared IPR, as well as on an equal footing with regard to the removal of
potential vulnerability from known Cisco IPR. Of course this may not be sufficient
for some who may still perceive a Cisco advantage from the potential to trade
its IPR in the case of RPL-related suits. However, such an advantage accrues to
any company that has developed IPR in the space. 
 
Hopefully there is a compromise that can allow the focus
to return to the RPL design and development.

Roger

----- Original Message ----
From: Don Sturek <[email-masked]>
To: Geoff Mulligan <[email-masked]>; Philip Levis <[email-masked]>
Cc: [email-masked]; Dan Lang <[email-masked]>; [email-masked]
Sent: Mon, February 15, 2010 9:17:55 PM
Subject: Re: [Roll] Closing on the IPR

Don

-----Original Message-----
From: [email-masked] [mailto:[email-masked]] On Behalf Of Geoff Mulligan
Sent: Monday, February 15, 2010 5:50 PM
To: Philip Levis
Cc: [email-masked]; Dan Lang; [email-masked]
Subject: Re: [Roll] Closing on the IPR

Phil,

    geoff

---

From: Robert Cragie <[email-masked]>
Date: Tue, 16 Feb 2010 11:52:50 +0000

Comments inline.

Robert Cragie (Pacific Gas & Electric)

Gridmerge Ltd.
89 Greenfield Crescent,
Wakefield, WF4 4WA, UK
+44 (0) 1924 910888
http://www.gridmerge.com <http://www.gridmerge.com/>

> vulnerable to the vagaries of other unknown IPR. 
<RCC>I fail to see how IPR can truly be unknown. Whilst it can be a very 
laborious process, a patent search will reveal other IPR. As far as I 
know (and I am not a lawyer) any other intellectual property which does 
not have a patent on it or patent pending cannot be considered as there 
is no formal declaration of the intellectual property or claims for it. 
Maybe a thorough patent search should be done, although I am not sure 
who would be prepared to undertake it. Maybe Cisco have already done due 
diligence due to assertion of their own IPR and can provide their 
assurance that there is no other potential IPR, although I appreciate 
they have no obligation to reveal this information.</RCC>
> legal rather than technical representatives).
<RCC>I agree that this would likely be a more acceptable proposal. I am 
not happy proceeding with RPL with the current statement on IPR and it 
would seem many others are not too.</RCC>

---

From: Philip Levis <[email-masked]>
Date: Tue, 16 Feb 2010 07:43:07 -0800

On Feb 16, 2010, at 3:52 AM, Robert Cragie wrote:

> http://www.gridmerge.com
> <RCC>I fail to see how IPR can truly be unknown. Whilst it can be a very laborious process, a patent search will reveal other IPR. As far as I know (and I am not a lawyer) any other intellectual property which does not have a patent on it or patent pending cannot be considered as there is no formal declaration of the intellectual property or claims for it. Maybe a thorough patent search should be done, although I am not sure who would be prepared to undertake it. Maybe Cisco have already done due diligence due to assertion of their own IPR and can provide their assurance that there is no other potential IPR, although I appreciate they have no obligation to reveal this information.</RCC>

It's also useful to note that the IETF has guidelines for IPR disclosure beyond the simple case we have here. The key part is 6.1.3 of RFC 3979:

6.1.2.  An IETF Participant's IPR in Contributions by Others

   Any individual participating in an IETF discussion who reasonably and
   personally knows of IPR meeting the conditions of Section 6.6 which
   the individual believes Covers or may ultimately Cover a Contribution
   made by another person, or which such IETF participant reasonably and
   personally knows his or her employer or sponsor may assert against
   Implementing Technologies based on such Contribution, must make a
   disclosure in accordance with this Section 6.

6.1.3.  IPR of Others

   If a person has information about IPR that may Cover IETF
   Contributions, but the participant is not required to disclose
   because they do not meet the criteria in Section 6.6 (e.g., the IPR
   is owned by some other company), such person is encouraged to notify
   the IETF by sending an email message to [email-masked].  Such a
   notice should be sent as soon as reasonably possible after the person
   realizes the connection.

Phil

---

From: Alexandru Petrescu <[email-masked]>
Date: Tue, 16 Feb 2010 18:25:27 +0100

Le 16/02/2010 00:33, Dan Lang a écrit :
> Hi Jon: I am not your lawyer, so I unfortunately won’t be able to
> compatible with the GPL?”) in way that satisfies you. However, I
> don’t think that having RPL inside the Linux kernel under a GPL
> license would somehow “protect” RPL and its implementers from patent
>  "troll" attacks.

Dan - do you think RPL could get _at all_ in the linux kernel were it to
have the BSD tag on it (as indicated in the RFC preamble), moreover the
IPR tag too?

I do not think so.  I do not think RPL as it stands has any chance to
get into the linux kernel.  It may be now in the kernel in the lab
experimentation but only until the right questions are made (e.g. "show
me the code").

Please comment,

Alex

> The entities you are worried about don’t typically have any
> products, and the GPL provides conditions on those who distribute or
> modify covered works, so they would not likely be bound by any of
> those conditions. If anything, they would have a larger pool of
> companies against which to assert their patents. Your last question
> highlights the risk of standard-setting generally; competitors or any
> third parties who aren’t participating in ROLL don’t necessarily have
> an obligation to disclose any of their patents to the IETF and may
> choose to wait until after the standard is finalized to demand fees
>  RPL-compliant products. This unfortunate fact will be true no matter
>  what the RPL specification looks like. Best regards, Dan
>
>
>> On Mon, Feb 15, 2010 at 12:41 AM, Dan Lang <[email-masked]
>> <mailto:[email-masked]>> wrote:
>>
>> Hi Ruben, A couple of points that I'd like to clarify in response
>> to your email. Again, I recommend that you check with your
>> company's attorneys but at least let me suggest some things to ask
>>  them about. 1. No one is being asked to "renounce their IPR." But,
>>  per our statement, an entity that wants to make money on or
>> otherwise exploit their patents against Cisco products might have
>> to pay something for a license to Cisco's patents. That seems fair
>>  to me, but more importantly, it seems fair to a lot of people who
>>  find sufficient assurance with our commitment to make numerous
>> IETF standards successful.
>>
>>
>> patents does not give you the right to use other patents if they
>> are relevant. Potential exposure to unknown third party patents is
>> large number of patents and the challenges of searching for them
>> and evaluating them, it would be almost impossible to reliably
>> identify all of the relevant patents for a particular product or
>> standard. But our patents and our licensing commitment are not the
>> cause of this problem. Even if our patents did not exist at all,
>> the problem would still be there. That is why I agree with some of
>> the commenters who pointed out that it is very difficult to avoid
>> Best regards, Dan
>> Dan Lang Director, Intellectual Property Legal Services Cisco
>> Systems, Inc.
>>
>> _______________________________________________ Roll mailing list
>> [email-masked] <mailto:[email-masked]>
>> -- Jon Smirl [email-masked] <mailto:[email-masked]>
>
>
>
> _______________________________________________ Roll mailing list
> [email-masked] https://www.ietf.org/mailman/listinfo/roll

---

From: Zach Shelby <[email-masked]>
Date: Tue, 16 Feb 2010 19:53:14 +0200

> experimentation but only until the right questions are made (e.g. "show

Alex. These are totally separate issues, do not mix them up. The text in the Internet-Draft template has absolutely nothing to do with the licensing of an implementation of that specification. Please keep your discussion regarding this to the appropriate IETF list, it really does not belong here. Thanks.

In my understanding, Cisco's IPR terms do not prevent a GPL implementation. Dan's point was that just because you use code licensed under GPL, that doesn't however protect you from being sued by someone else claiming that code infringes on their IPR (e.g. by patent trollers). 

Zach

-- 
http://www.sensinode.com
http://zachshelby.org - My blog "On the Internet of Things"
http://6lowpan.net - New book - "6LoWPAN: The Wireless Embedded Internet"
Mobile: +358 40 7796297

Zach Shelby
Head of Research
Sensinode Ltd.
Kidekuja 2
88610 Vuokatti, FINLAND

This e-mail and all attached material are confidential and may contain legally privileged information. If you are not the intended recipient, please contact the sender and delete the e-mail from your system without producing, distributing or retaining copies thereof.

---

From: Jon Smirl <[email-masked]>
Date: Tue, 16 Feb 2010 13:40:11 -0500

> have the BSD tag on it (as indicated in the RFC preamble), moreover the

This is a problem specific to implementations, not with the spec. The
GPL is a superset of the BSD license. The detailed procedures for
bringing BSD code into Linux are described here:
http://www.softwarefreedom.org/resources/2007/gpl-non-gpl-collaboration.html
I don't know of any issues with bringing BSD licensed code in to Linux
if these procedures are followed.

> experimentation but only until the right questions are made (e.g. "show

The quickest way to keep RPL out of Linux is to require a patent
royalty on implementations of it. The GPL explicitly prohibits
royalties. There are multiple solutions to royalties: avoid patents in
RPL, statements of non-assertion against RPL implementations, explicit
licenses granting royalty free use in GPL'd code, etc. Those work for
known patents, there is nothing anyone can do about trolls without
changing the patent system.

As long as no one is standing up and saying that they want royalties
on RPL I see no problem with implementing it in Linux. If someone
stands up later (like Microsoft did with FAT) there will be problems
and the code will get removed. Of course we can't tell right now if
anyone is going to make later claims.

If a BSD licensed RPL implementation is already available I can start
looking at bringing it into Linux. I'd prefer to port tested code than
start from scratch. Low level 802.15.4 support is already in the
kernel. 6lowpan has not been added yet but I believe Dimitry is
working on it.

-- 
Jon Smirl
[email-masked]

---

From: Alexandru Petrescu <[email-masked]>
Date: Tue, 16 Feb 2010 20:11:43 +0100

Le 16/02/2010 18:53, Zach Shelby a écrit :
>>>  license would somehow “protect” RPL and its implementers from
>>> patent "troll" attacks.
>>
>> Dan - do you think RPL could get _at all_ in the linux kernel were
>> it to have the BSD tag on it (as indicated in the RFC preamble),
>> moreover the IPR tag too?
>>
>> I do not think so.  I do not think RPL as it stands has any chance
>> to get into the linux kernel.  It may be now in the kernel in the
>> lab experimentation but only until the right questions are made
>> (e.g. "show me the code").
>
> Alex. These are totally separate issues, do not mix them up. The
> text in the Internet-Draft template has absolutely nothing to do with
> the licensing of an implementation of that specification.

I am not sure why you think they're separate issues.  In my experience
both the boilerplate conditions and the IPR conditions are tightly
coupled.  One RFC I co-authored had two IPR tags on them, one
specifically saying "open source".

> Please keep your discussion regarding this to the appropriate IETF
> list, it really does not belong here. Thanks.

Which IETF list please?  I started something in the ipr-wg list only to
realize it's not anylonger an IETF list (WG IPR closed or so).  I am not
sure where to do it properly.

> In my understanding, Cisco's IPR terms do not prevent a GPL
> implementation. Dan's point was that just because you use code
> licensed under GPL, that doesn't however protect you from being sued
> by someone else claiming that code infringes on their IPR

I agree.

Moreover, explicit IPR conditions has even less chances of the GPL
conditions to protect me.

> (e.g. by patent trollers).

What's a patent troller?

Alex

---

From: Alexandru Petrescu <[email-masked]>
Date: Tue, 16 Feb 2010 20:41:23 +0100

Le 16/02/2010 19:40, Jon Smirl a écrit :
> This is a problem specific to implementations, not with the spec.

I agree the BSD-or-no-BSD is specific to implementations and should stay
that way.  I don't understand why this RFC must say "BSD" if a
particular implementation absolutely wants to say exclusively GPL and no
BSD.  (or any other yet-to-be-written license scheme).

> The GPL is a superset of the BSD license. The detailed procedures for

(I will say again as I usually say in this WG: please don't point me
to non-IETF urls I don't read them usually).

That url gives advice about text to be added at the top of the files in
order to make it work BSD-together-with-other-license.  I do not want
it.  I want to write my own license the way I want, sorry.

> I don't know of any issues with bringing BSD licensed code in to
> Linux if these procedures are followed.

I could give you examples.  Recently a poster pointed to an existing
license in the linux kernel telling how BSD and GPL could live together.
  That license says something like this: "Copyright Widget...
Alternatively... GPL".  That is pure nonsense, because neither Widget is
sure to keep its name nor GPL is sure to have it
source-offered-on-demand.  This is trouble waiting to happen.

> royalty on implementations of it.

I agree, mostly.  Sometimes it can happen without going as far as asking
royalties.  There are watchdog organizations making sure GPL is
enforced.  When they employ lawyers only to check GPL is respected then
big things happen for commercial actors.  I could cite examples.

Implementer should protect code the way s/e better feels, not the way
BSD or IETF or particular company believes it should.  There are many
commercial interests and rarely are they compatible.

> The GPL explicitly prohibits royalties. There are multiple solutions
> to royalties: avoid patents in RPL, statements of non-assertion
> against RPL implementations, explicit licenses granting royalty free
> use in GPL'd code, etc. Those work for known patents, there is
> nothing anyone can do about trolls without changing the patent
> system.
>
>  on RPL I see no problem with implementing it in Linux.

Even if IPR royalties are not demanded I see a problem: particular
company implements RPL in linux kernel, linux maintainers ask for GPL,
company says ok.  Then another company asks for the source code.  First
company says no.  And here go problems without IPR being involved.

> If someone stands up later (like Microsoft did with FAT) there will
> be problems and the code will get removed. Of course we can't tell
> right now if anyone is going to make later claims.

Not only companies like Microsoft can ask for rights and accuse of IPR
infringement.  Interests watching for GPL enforcement can also make
statements hurting.  And I can say I saw it happening.

> looking at bringing it into Linux.

People tried too in the past, for the TCP/IP stack for example.  They
finished by rewriting code.

Fortunately TCP/IP specs don't have that "BSD" tag, earlier than IETF
Trust. (check for example defrag code in IPv6 rfc2460 - fortunately it
doesn't have the BSD tag on it).

> I'd prefer to port tested code than start from scratch.

I fully agree.  I prefer too to use code from RFCs, but if code in RFC
has that BSD tag then it's all useless, have to rewrite.

> Low level 802.15.4 support is already in the kernel.

Hmm... is IEEE happy with the GPL in the linux kernel?  Are the kernel
maintainers happy with the IPRs claimed by some IEEE contributors?  If
any doubt - that spells trouble waiting to happen.

> 6lowpan has not been added yet but I believe Dimitry is working on
> it.

IMHO, let me indulge myself an advice to Dmitry: don't implement until
it's an RFC :-); mostly for technical reasons, but licensing too.

Alex

>>> products, and the GPL provides conditions on those who
>>> distribute or modify covered works, so they would not likely be
>>> bound by any of those conditions. If anything, they would have a
>>> larger pool of companies against which to assert their patents.
>>> Your last question highlights the risk of standard-setting
>>> generally; competitors or any third parties who aren’t
>>> participating in ROLL don’t necessarily have an obligation to
>>> disclose any of their patents to the IETF and may choose to wait
>>> until after the standard is finalized to demand fees (and not
>>> necessarily on reasonable and non-discriminatory terms) for
>>> RPL-compliant products. This unfortunate fact will be true no
>>> matter what the RPL specification looks like. Best regards, Dan
>>>
>>>
>>>> On Mon, Feb 15, 2010 at 12:41 AM, Dan Lang<[email-masked]
>>>> Hi Ruben, A couple of points that I'd like to clarify in
>>>> response to your email. Again, I recommend that you check with
>>>> your company's attorneys but at least let me suggest some
>>>> things to ask them about. 1. No one is being asked to
>>>> "renounce their IPR." But, per our statement, an entity that
>>>> wants to make money on or otherwise exploit their patents
>>>> against Cisco products might have to pay something for a
>>>> importantly, it seems fair to a lot of people who find
>>>> From a legal sense, is your statement compatible with the GPL?
>>>> I just want to ensure that we can build a GPL'd version of RPL.
>>>> I don't want to repeat the problems with Zigbee where their
>>>> licensing is incompatible with the GPL.
>>>>
>>>> 2. We would never claim that our intellectual property
>>>> provides an "umbrella" for the industry. Having the right to
>>>> use one company's patents does not give you the right to use
>>>> other patents if they are relevant. Potential exposure to
>>>> unknown third party patents is always a concern in the
>>>> information technology industry. Due to the large number of
>>>> patents and the challenges of searching for them and evaluating
>>>> them, it would be almost impossible to reliably identify all of
>>>> the relevant patents for a particular product or standard. But
>>>> our patents and our licensing commitment are not the cause of
>>>> this problem. Even if our patents did not exist at all, the
>>>> problem would still be there. That is why I agree with some of
>>>> the commenters who pointed out that it is very difficult to
>>>> avoid intellectual property concerns entirely because they
>>>> cannot all be known.
>>>>
>>>>
>>>> Trolls are everywhere and can't be identified ahead of time.
>>>> Do you feel that the GPL and the set of companies surrounding
>>>> the Linux kernel somewhat protects it from troll attacks?
>>>> Would implementing the reference version of RPL inside the
>>>> Linux kernel provide added protection to RPL users?
>>>>
>>>> direct competitors who aren't participating in ROLL and might
>>>> be interested in disrupting ROLL?
>>>>
>>>> Best regards, Dan
>>>>
>>>>
>>>>
>>>>
>>>> _______________________________________________ Roll mailing
>>>> list [email-masked]<mailto:[email-masked]>
>>>> -- Jon Smirl [email-masked]<mailto:[email-masked]>
>>>
>>>
>>>

---

From: Adrian Farrel <[email-masked]>
Date: Wed, 17 Feb 2010 00:36:41 +0000

> sure where to do it properly.

The IETF Trust Legal Provisions are described at 
http://trustee.ietf.org/license-info/

It states...

   The Trustees request that discussion of this topic be on the tlp-interest 
list,
   [email-masked], with cc to [email-masked] . This list can be 
joined
   here: https://www.ietf.org/mailman/listinfo/tlp-interest

Thanks,
Adrian

---

From: Adrian Farrel <[email-masked]>
Date: Wed, 17 Feb 2010 00:44:48 +0000

Hi,

As per my previous mail, discussions of the content and intent of the TLP 
can be had on the tlp-interest mailing list with the participation of the 
trustees.

They have chosen a specific wording for inclusion in I-Ds and RFCs according 
to their judgement and the advice they have received. From our point of view 
we can choose to debate it, but we cannot vary from it within the IETF.

It is also clear that any code extracted from an I-D or RFC must conform to 
the license terms as set out in the TLP.

Further discussion of whether it is appropriate to say one thing or another 
within a ROLL I-D is, therefore, not fruitful on this mailing list. The I-D 
will say what it must say unless and until the rules are changed.

Thanks,
Adrian

----- Original Message ----- 
From: "Alexandru Petrescu" <[email-masked]>
To: "Jon Smirl" <[email-masked]>
Cc: <[email-masked]>
Sent: Tuesday, February 16, 2010 7:41 PM
Subject: Re: [Roll] Closing on the IPR

Alex